#ifndef __HITECK_IPC_H
#define __HITECK_IPC_H

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

#define MAX_SEND_SIZE 300

struct mymsgbuf
{
        long mtype;
        char mtext[MAX_SEND_SIZE];
};

#ifndef FALSE
#define FALSE 0
#endif


#ifndef TRUE   
#define TRUE  !FALSE
#endif
 
extern struct mymsgbuf ipc_qbuf;

extern int  ipc_init(key_t key);
extern void ipc_send_message(int qid, long type, char *text);
extern void ipc_read_message(int qid, long type);
extern void ipc_read_message_nowait(int qid, long type);
extern void ipc_remove_queue(int qid);
extern void ipc_change_queue_mode(int qid, char *mode);
extern int  ipc_peek_message(int qid, long type);

#endif
