#include "ipc_shm.h"

int ipc_init_shm(long key, long bytes)
{
	int shmid;

        if((shmid = shmget(key, bytes, IPC_CREAT|IPC_EXCL|0666)) == -1) 
        {
                if((shmid = shmget(key, bytes, 0)) == -1) 
                {
                        perror("shmget");
                        exit(1);
                }
/*		memset(shmat(shmid, 0, 0), 0, bytes); */
        }
	else
		memset(shmat(shmid, 0, 0), 0, bytes);

	return shmid;
}

void ipc_remove_shm(int shmid)
{
        shmctl(shmid, IPC_RMID, 0);
}

char *ipc_smptr(int shmid)
{
	char *segptr;

        if((int)(segptr = shmat(shmid, 0, 0)) == -1)
        {
                perror("shmat");
                exit(1);
        }
	return segptr;
}
