#ifndef __HITECK_TTT_H
#define __HITECK_TTT_H

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>

#include "curses.h"
#include "ntalk.h"
#include "vt100.h"


#define GRIDXSIZE 79
#define GRIDYSIZE 16
#define BLANKCHAR '.'

#define USERFILE "/home/hiteck/tttdata"

#define PLAYER_1 42
#define PLAYER_2 43
#define M_SERVER 1
#define M_CLIENT 2


typedef struct 
{
        char name[16];
        int win, lose, quit;
} user_data;


extern char grid[GRIDXSIZE][GRIDYSIZE];

extern char *keyset;
extern int mark_x, mark_y;

void grid_render();
void draw_text(int x, int y, char *text);
void grid_draw_mark(int x, int y);
void grid_draw_inverse_mark(int x, int y);
int  check_for_mark(int x, int y, char mark);
char check_for_win();
void grid_init();
int  place_mark(char *mark);
int  ttt_play(int mode, int local, int remote);

#endif

