/*
 *  VT-specific stuff by Sami Kystil
 */


#include "vt100.h"

#define VT_BOLD "\x1B[1m"
#define VT_NORMAL "\x1B[0m"
#define VT_UNDERSCORE "\x1B[4m"
#define VT_BLINK "\x1B[5m"
#define VT_REVERSE "\x1B[7m"

#define VT_ERASE "\x1B[K"

void flip(char *buffer)
{
	printf("\x1B[0m\x1B[0;0H%s", buffer);
	fflush(stdout);
}

void cursor_set(int x, int y)
{
	printf("%c[%d;%dH", 27, y, x);
}

void cursor_reset(void)
{
	printf("%cH", 27);
}
