/*
 *  VT-specific stuff by Sami Kystil
 */


#ifndef __HITECK_VT100_H
#define __HITECK_VT100_H

#include <stdio.h>

#define VT_BOLD "\x1B[1m"
#define VT_NORMAL "\x1B[0m"
#define VT_UNDERSCORE "\x1B[4m"
#define VT_BLINK "\x1B[5m"
#define VT_REVERSE "\x1B[7m"

#define VT_ERASE "\x1B[K"

void flip(char *buffer);
void cursor_set(int x, int y);
void cursor_reset(void);

#endif
